<template>
    <div class="admin_page">
		<div class="admin_table_search">
			<div class="admin_state">
			
				<div class="admin_state_item">
					<span>Select Time:</span>
					<a-range-picker
						style="width:250px"
						class="range_picker"
						v-model:value="rangePickerValue"
						:placeholder="[
							$t('HistoryPage.StartDate'),
							$t('HistoryPage.EndDate'),
						]"
						valueFormat="YYYY-MM-DD"
					>
						<template #suffixIcon>
							<span
								class="icon iconfont range_picker_icon icon-rili"
							></span>
						</template>
					</a-range-picker>
				</div>
				<div class="admin_state_item">
                    <span>Country:</span>
					<a-select
                        v-model:value="country"
						:allowClear="true"
						show-search
                        style="width: 250px"
                        :filter-option="filterOption"
                        placeholder="Select Item..."
                        max-tag-count="responsive"
                        :options="allCountry"
                    ></a-select>
                </div>
                <div class="admin_state_item">
                    <span>Email:</span>
                    <input
                        v-model="email"
                        placeholder="Please enter email"
                        @keydown.enter="gettrialList"
                        type="text"
                        style="width: 250px"
                    />
                </div>
                <div class="admin_state_item">
                    <span>User Name:</span>
                    <a-select
                        v-model:value="ids"
                        mode="multiple"
                        style="width: 250px"
                        :filter-option="filterOption"
                        placeholder="Select Item..."
                        max-tag-count="responsive"
                        :options="allUserList"
                        @keydown.enter="gettrialList"
                    ></a-select>
                </div>
			</div>
			<div class="admin_search">
				<div class="admin_search_item" @click="searchHistoryList">Search</div>
			</div>
			<div class="admin_state_list">
				<div class="admin_state_list_item" @click="lastGeTrialList('year')">Nearly a year</div>
				<div class="admin_state_list_item" @click="lastGeTrialList('month')">Last month</div>
				<div class="admin_state_list_item" @click="lastGeTrialList('week')">Last week</div>
			</div>
		</div>

		<div class="admin_table_content" ref="historyTable">
			<a-table
				@resizeColumn="handleResizeColumn"
				:loading="tableLoading"
				:columns="columns"
				:data-source="dataList"
				:scroll="{ y: historyTableHeight }"
				@change="changePage"
				:showSorterTooltip='false'
				:pagination="{
					showSizeChanger: true,
					current: currentPage,
					pageSize: pageSize,
					total: total,
					showQuickJumper: true,
					bordered: false,
				}"
			>
			</a-table>
		</div>
    </div>
</template>
<script lang="ts">
import { defineComponent, ref, createVNode, computed, reactive, toRefs, onMounted } from "vue";
import { formatTime } from "@/tool/util";
import { useStore } from "vuex";
import { Https } from "@/tool/https";
export default defineComponent({
    components: {
    },
    setup() {
        const store:any = useStore()
        let filter:any =  reactive({
			dataList:[],
			tableLoading:false,
			allUserList: computed(()=>{
				return store.state.adminPage.allUserList
			}),
			allCountry:[]
		})
		let filterData:any = reactive({
			rangePickerValue:[],
			currentPage: 1,
            pageSize: 10,
            total: 0,
			country: "",
            email: "",
            userType: "",
            ids: [],
            occupation: "",
            order: "", //'Ascending  升序 Descending 降序'
			orderBy:'',
            userName: "",
		})
	
        let renameData: any = ref({}); //修改名字选中的数据
        const columns: any = computed(() => {
            return [
				
				{
                    title: 'User Id',
                    align: "center",
                    width: 100,
                    fixed: "left",
					sorter: true,
                    dataIndex: "id",
                    key: "id",
                },
				{
                    title: 'User Name',
                    align: "center",
                    ellipsis: true,
                    width: 150,
                    dataIndex: "userName",
                    key: "userName",
                },
				{
                    title: 'Email',
                    align: "center",
                    ellipsis: true,
                    width: 200,
                    dataIndex: "email",
                    key: "email",
                },
				{
                    title: 'Given Name',
                    align: "center",
                    ellipsis: true,
                    width: 100,
                    dataIndex: "givenName",
                    key: "givenName",
                },
                {
                    title: 'Create Date',
                    align: "center",
                    width: 200,
					ellipsis:true,
                    dataIndex: "createTime",
                    key: "createTime",
					sorter: true,
                },
				{
                    title: 'Title',
                    align: "center",
                    ellipsis: true,
                    width: 100,
					// 
                    dataIndex: "title",
                    key: "title",
                },
				{
                    title: 'Country',
                    align: "center",
                    width: 100,
                    ellipsis: true,
                    dataIndex: "country",
                    key: "country",
                },
				
            ];
        });
		//改变页码
		let changePage = (e: any, filters:any, sorter:any) => {
            filterData.currentPage = e.current;
            filterData.pageSize = e.pageSize;
			if(sorter.order){
				if(sorter.columnKey == 'id'){
					filterData.orderBy = 'id'
				}else if(sorter.columnKey == "createDate"){
					filterData.orderBy = 'time'
				}
			}
			filterData.order = sorter.order == "descend" ? "Descending" : "Ascending";
            gettrialList();
        }

        //查询列表
        let searchHistoryList = ()=> {
            filterData.currentPage = 1;
            gettrialList();
        }

		//获取列表
        let gettrialList = () =>{
			filter.tableLoading = true
			let startDate: any = filterData.rangePickerValue?.[0]
                ? filterData.rangePickerValue[0]+' '+'00:00:00'
                : "";
            let endDate: any = filterData.rangePickerValue?.[1]
                ? filterData.rangePickerValue[1]+' '+'23:59:59'
                : "";
			let data = {
				endTime:endDate,
				startTime:startDate,
				size: filterData.pageSize,
                page: filterData.currentPage,
                country: filterData.country,
                email: filterData.email,
                userType: filterData.userType,
                ids: filterData.ids,
                occupation: filterData.occupation,
                order: filterData.order,
                orderBy: filterData.orderBy,
                userName: filterData.userName,
			}
			Https.axiosPost(Https.httpUrls.inquiryGetTrial,data).then((rv: any) => {
				if (rv) {
					// this.dataList = rv
					filter.dataList = rv.records
					filterData.total = rv.total
					filter.tableLoading = false
					
					// this.workspaceItem.position = this.singleTypeList[0].label
				}
			})
        }
		let filterOption = (input: any, option: any) => {
            // 使用 option.label 进行搜索
            return option.label.toLowerCase().indexOf(input.toLowerCase()) >= 0;
        };
		let lastGeTrialList = (str:string)=>{
			let currentDate = new Date();
			let currentTimestamp = Math.floor(currentDate.getTime()  / 1000);
			// 计算30天前的时间戳
			let thirtyDaysAgoTimestamp
			if(str == 'year'){
				thirtyDaysAgoTimestamp = currentTimestamp - (360 * 24 * 60 * 60);
			}else if(str == 'month'){
				thirtyDaysAgoTimestamp = currentTimestamp - (30 * 24 * 60 * 60);
			}else if(str == 'week'){
				thirtyDaysAgoTimestamp = currentTimestamp - (7 * 24 * 60 * 60);
			}
			filterData.rangePickerValue = [formatTime(thirtyDaysAgoTimestamp,'YYYY-MM-DD'),formatTime(currentTimestamp,'YYYY-MM-DD')]
			gettrialList();
		}
		onMounted(()=>{
			let allCountry: any = sessionStorage.getItem("allCountry");
            if (allCountry) {
                filter.allCountry = JSON.parse(allCountry);
            }
			lastGeTrialList('month')
		})
        return {
			...toRefs(filter),
			...toRefs(filterData),
            columns,
            renameData,
			changePage,
			filterOption,
			searchHistoryList,
			lastGeTrialList,
			gettrialList,
        };
    },
    data() {
        return {
            
            historyTableHeight: 0,
			handleResizeColumn: (w:any, col:any) => {
				col.width = w;
			},
        };
    },
    mounted() {
        let historyTable: any = this.$refs.historyTable;
        this.historyTableHeight = historyTable.clientHeight - 200;
    },
    methods: {
        
    },
});
</script>

<style lang="less" scoped>
.admin_page .admin_table_search .admin_state {
    display: flex;
    flex-wrap: wrap;
}
</style>
